---
title: Window.getSelection()
slug: Web/API/Window/getSelection
tags:
  - API
  - HTML DOM
  - Method
  - Reference
  - Selection
  - Selection API
  - Window
---
<div>{{ ApiRef() }}</div>

<p>The <code><strong>Window.getSelection()</strong></code> method returns a {{domxref("Selection")}} object representing the range of text selected by the user or the current position of the caret.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>selection</em> = <em>window</em>.getSelection();</pre>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("Selection")}} object.</p>

<p>When cast to string, either by appending an empty string (<code>""</code>) or using {{domxref("Selection.toString()")}}, this object returns the text selected.</p>

<p>When called on an {{htmlelement("iframe")}} that is not displayed (eg. where <code>display: none</code> is set) Firefox will return <code>null</code>, whereas other browsers will return a {{domxref("Selection")}} object with {{domxref("Selection.type")}} set to <code>None</code>.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush:js">function foo() {
    var selObj = window.getSelection();
    alert(selObj);
    var selRange = selObj.getRangeAt(0);
    // do stuff with the range
}</pre>

<h2 id="Notes">Notes</h2>

<h3 id="String_representation_of_the_Selection_object">String representation of the Selection object</h3>

<p>In JavaScript, when an object is passed to a function expecting a string (like {{ Domxref("window.alert()") }} or {{ Domxref("document.write()") }}), the object's {{jsxref("Object.toString", "toString()")}} method is called and the returned value is passed to the function. This can make the object appear to be a string when used with other functions when it is really an object with properties and methods.</p>

<p>In the above example, <code>selObj.toString()</code> is automatically called when it is passed to {{domxref("window.alert()")}}. However, attempting to use a JavaScript <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/String" title="JS/String">String</a> property or method such as <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/length" title="JS/String.length">length</a></code> or <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/substr" title="JS/String.substr">substr</a></code> directly on a {{domxref("Selection")}} object will result in an error if it does not have that property or method and may return unexpected results if it does. To use a <code>Selection</code> object as a string, call its <code>toString()</code> method directly:</p>

<pre class="brush:js;gutter:false;">var selectedText = selObj.toString();</pre>

<ul>
 <li><code>selObj</code> is a <code>Selection</code> object.</li>
 <li><code>selectedText</code> is a string (Selected text).</li>
</ul>

<h3 id="Related_objects">Related objects</h3>

<p>You can call {{domxref("Document.getSelection()")}}, which works identically to <code>Window.getSelection()</code>.</p>

<p>It is worth noting that currently <code>getSelection()</code> doesn't work on the content of {{htmlelement("textarea")}} and {{htmlelement("input")}} elements in Firefox, Edge (Legacy) and Internet Explorer. {{domxref("HTMLInputElement.setSelectionRange()")}} or the <code>selectionStart</code> and <code>selectionEnd</code> properties could be used to work around this.</p>

<p>Notice also the difference between <em>selection</em> and <em>focus</em>. {{domxref("Document.activeElement")}} returns the focused element.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("Selection API", "#extensions-to-window-interface", "Window.getSelection()")}}</td>
   <td>{{Spec2("Selection API")}}</td>
   <td>New spec.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Window.getSelection")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Selection_API">Selection API</a></li>
 <li>{{domxref("Selection")}}</li>
 <li>{{domxref("Range")}}</li>
 <li>{{domxref("Document.getSelection()")}}</li>
 <li>{{domxref("HTMLInputElement.setSelectionRange()")}}</li>
</ul>
